;;Generic macros from Nagoa+.inc

; NAGOA made by  PedroGC Aka  Nguga
;-----------------------------------------------------------------------------------
; Greetings to everyone on that helps build NAGOA.inc   here the people  :
;=====================================================
; Sven B. Schreiber, Philippe Auphelle, Gij, Iczelion,
; Steve Hutchesson, Barry Kauler, Wayne Radburn, Kaproncai Tams
; Anton Eremeev ,nuMIT_or , David Arnoldo Ortiz Lozano,
; mastercpp , Luckystar , Frank B. Kotler , Vecna , William Swanson ,highenergy
;-----------------------------------------------------------------------------------

;======================================================
;  CALL is real assembly instruction "call" is a macro but if you do not like use instead
;  call_ or invoke or stdcall  and then   CALL = call  assembly instruction , 
;  for that just comment this line above .
;-------------------------------------------------------------------------------------
%define call call_   ; comment this line  if you do not like "call" macro 
;-------------------------------------------------------------------------------------
;======================================================




;---------------------------------------------------------------------------------------

%idefine elif		elseif
%idefine nasm		call_
%idefine stdcall	                  call_
%idefine invoke		call_
%idefine local		stack
%idefine addr_		"ADDR_",
%idefine addr		"ADDR_",

%define false		0
%define true		1
%define TRUE 1
%define FALSE 0
%define NULL 0


;=== HGB THANKS !
%macro def 1
        definir %1
%endmacro

%macro definir 1
        %define %1_definida
%endmacro
;=============


%imacro call_ 1-*  
%assign i	%0
	%if %0 > 1
		%rep %0 - 1
			%rotate -1  
			%assign i	i-1		                               
			%rotate -1
			%ifidni %1,"ADDR_"
			%rotate 1
			lea	eax,	[%1]
			push	eax
			%rotate -1
			%assign i	i-1
			%else		
			%rotate 1
			STDPUSH {%1}     
			%endif
			%if i <=1
			%exitrep
			%endif
		%endrep		
		%rotate -1
	%endif
	%ifid %1
		%ifdef %1_definida
			; uma  funao local
			CALL %1
		%else
			%ifdef ONLY_NASM
				CALL [%1]
			%else
				extern %1
				CALL [%1]
			%endif
		%endif
	%else
		CALL %1
	%endif
%endmacro



;=== [ end macro call_ ] =====================




;****************************************************
;                                       HLL macros
;****************************************************
;  - for/next
;
%imacro for 5
        %push for
        %define %$v %1
        %define %$c %3
        %define %$e %4
        %define %$s %5
        mov     %1, %2
%$f:
%endmacro
%imacro next 0
        %ifctx for
                add     %$v, %$s
                cmp     %$v, %$e
                j%$c    near %$f
                %pop
        %else
                ; %error "Expected 'for' before 'next'"
        %endif
%endmacro
;

;
; HLL macros - if/elseif/else/ifand/endif
;
%imacro if 3-*
        %push if
	%$if:
	%assign %$i 1
        %if %0 = 3
                cmp     %1, %3
                j%-2    near %$else_%$i
        %else
                %assign %$c 0
                %rep (%0 / 3)
                        cmp     %1,%3
                        j%2     near %$c_%$i
                        %rotate 3
                %endrep
                jmp     near %$else_%$i
		%$c_%$i:
        %endif
%endmacro

%imacro ifand 3-*
        %push if
	%$if:
	%assign %$i 1
        %if %0 = 3
                cmp     %1, %3
                j%-2    near %$else_%$i
        %else
                %rep (%0 / 3)
                        cmp     %1, %3
                        j%-2    near %$else_%$i
                        %rotate 3
                %endrep
        %endif
%endmacro

%imacro elseif 3-*.nolist
	%ifctx if
		jmp	near %$endif
		%$else_%$i:
		%assign %$i %$i+1
		%if %0=3
			cmp %1,%3
			j%-2 near %$else_%$i
		%else		
			%rep (%0 / 3)
				cmp %1,%3
				j%2 near %$c_%$i
				%rotate 3
			%endrep
			jmp     near %$else_%$i
			%$c_%$i:
		%endif
	%else
		%error "'ELSEIF' can only be used following 'IF'"
	%endif
%endmacro


%imacro else 0
        %ifctx if
                jmp     near %$endif
                %$else_%$i:
		%assign %$i %$i+1
        %else
                %error "Expected 'if' or 'ifand' before 'else'"
        %endif
%endmacro
%imacro endif 0.nolist
        %ifctx if
		%$else_%$i:
		%$endif:
		%pop
        %else
                %error "Expected 'if' before 'endif'"
        %endif
%endmacro
;***************************





;***************************
; HLL macros - repeat/until
;
%imacro repeat 0
        %push repeat
%$r:
%endmacro
%imacro until 3-*
        %ifctx repeat
                %if %0 = 3
                        cmp     %1, %3
                        j%-2    near %$r
                %else
                        %rep (%0 / 3)
                                cmp     %1, %3
                                j%-2    near %$r
                                %rotate 3
                        %endrep
                %endif
                %pop
        %else
                ; %error "Expected 'repeat' before 'until'"
        %endif
%endmacro
%imacro untiland 3-*
        %ifctx repeat
                %if %0 = 3
                        cmp     %1, %3
                        j%-2    near %$r
                %else
                        %rep (%0 / 3)
                                cmp     %1, %3
                                j%2     near %$x
                                %rotate 3
                        %endrep
                        jmp     %$r
                        %$x:
                %endif
                %pop
        %else
                ; %error "Expected 'repeat' before 'untiland'"
        %endif
%endmacro

;****************************************
; HLL macros - switch
;
%imacro switch 1
        %push switch
        %define %$v %1
        %assign %$c 0
%endmacro
%imacro case 1-*
        %ifctx switch
                %$s%$c:
                %assign %$c %$c + 1
                %if %0 = 1
                        cmp     %$v, %1
                        jne     near %$s%$c
                %else
                        %rep %0
                                cmp     %$v, %1
                                je      near %$sc%$c
                                %rotate 1
                        %endrep
                        jmp     %$s%$c
                        %$sc%$c:
                %endif
                %repl case
        %else
                ; %error "Expected 'switch' before 'case' or missing 'break' in previous 'case'"
        %endif
%endmacro
%imacro caseand 1-*
        %ifctx switch
                %$s%$c:
                %assign %$c %$c + 1
                %if %0 = 1
                        cmp     %$v, %1
                        jne     near %$s%$c
                %else
                        %rep %0
                                cmp     %$v, %1
                                jne     near %$s%$c
                                %rotate 1
                        %endrep
                %endif
                %repl case
        %else
                ; %error "Expected 'switch' before 'caseand' or missing 'break' in previous 'case'"
        %endif
%endmacro
%imacro range 2-*
        %ifctx switch
                %if %0 = 2
                        %$s%$c:
                        %assign %$c %$c + 1
                        cmp     %$v, %1
                        jl      near %$s%$c
                        cmp     %$v, %2
                        jg      near %$s%$c
                %else
                        %$s%$c:
                        %assign %$c %$c + 1
                        %assign %$d 100
                        %rep (%0 / 2)
                                        cmp     %$v, %1
                                        jl      %$sr%$d
                                        cmp     %$v, %2
                                        jle     near %$sre%$c
                                %$sr%$d:
                                %assign %$d %$d + 1
                                %rotate 2
                        %endrep
                        jmp     %$s%$c
                        %$sre%$c:
                %endif
                %repl case
        %else
                ; %error "Expected 'switch' before 'range' or missing 'break' in previous 'case'"
        %endif
%endmacro
%imacro rangeand 2-*
        %ifctx switch
                %if %0 = 2
                        %$s%$c:
                        %assign %$c %$c + 1
                        cmp     %$v, %1
                        jl      near %$s%$c
                        cmp     %$v, %2
                        jg      near %$s%$c
                %else
                        %$s%$c:
                        %assign %$c %$c + 1
                        %rep (%0 / 2)
                                        cmp     %$v, %1
                                        jl      near %$s%$c
                                        cmp     %$v, %2
                                        jg      near %$s%$c
                                %rotate 2
                        %endrep
                %endif
                %repl case
        %else
                ; %error "Expected 'switch' before 'rangeand' or missing 'break' in previous 'case'"
        %endif
%endmacro
%imacro break 0
        %ifctx case
                jmp     %$e
                %repl switch
        %else
                ; %error "Expected 'case' before 'break'"
        %endif
%endmacro
%imacro default 0
        %ifctx switch
                %$s%$c:
                %assign %$c %$c + 1
        %else
                ; %error "Expected 'switch' before 'default'"
        %endif
%endmacro
%imacro switchend 0
        %ifctx switch
                %$e:
                %$s%$c:
                %pop
        %else
                ; %error "Expected 'switch' before 'switchend'"
        %endif
%endmacro


;*************************************************
; HLL macros - while/wend
;
%imacro while 3-*
        %push while
        %$w:
        %if %0 = 3
                cmp     %1, %3
                j%-2    near %$x
        %else
                %assign %$c 0
                %rep (%0 / 3)
                        cmp     %1, %3
                        j%2     near %$w%$c
                        %rotate 3
                %endrep
                jmp     %$x
                %$w%$c:
        %endif
%endmacro
%imacro whileand 3-*
        %push while
        %$w:
        %if %0 = 3
                cmp     %1, %3
                j%-2    near %$x
        %else
                %assign %$c 0
                %rep (%0 / 3)
                        cmp     %1, %3
                        j%-2    near %$x
                        %rotate 3
                %endrep
        %endif
%endmacro
%imacro wend 0
        %ifctx while
                jmp     %$w
        %$x:
                %pop
        %else
                ; %error "Expected 'while' before 'wend'"
        %endif
%endmacro

;****************************************************
;            end                HLL macros
;****************************************************






; ----  Anton Eremeev  edit PedroGC

;=====================================================
 %imacro CONST 2+	; macro to insert constant into code
	jmp near %%skip	; jump to macro-local label
	%1 %2		; mark label and define data
	%%skip:		; macro-local label
 %endm
;======================================================




%macro STDPUSH 1				; macro to push argument list
	%ifnum %1				; argument is a number
						; check number to fit in signed byte
		%if %1 >= -128 && %1 <= 127
			push byte %1
		%else				; cannot be pushed as signed byte
			push dword %1
		%endif
	%else					; argument is not a number
		%ifstr %1			; argument is a string
			CONST %%str, db %1, 0	; define macro-local label
			push dword %%str
		%else				; neither string nor number (label or register)
			push dword %1
		%endif
	%endif
%endmacro





; -------> FOR WIN32API use : call or stdcall or invoke
%imacro ccall 1-*.nolist
	%push ccall
	%assign %$i %0-1
	%assign %$params %0-1
	%rep %0-1
		%rotate -1  
			%assign %$i	%$i-1
			%rotate -1
			%ifidni %1,"addr"
				%rotate 1
				lea eax,[%1]
				push eax
				%rotate -1
				%assign %$i %$i-1
			%else		
				%rotate 1
				STDPUSH {%1}
			%endif
			%if %$i=0
				%exitrep
			%endif
	%endrep
	%rotate -1
	%ifid %1
		%ifdef %1_definida
			CALL %1
			%assign %$params %$params*4
			%if %$params <> 0
				add esp,%$params
			%endif
		%else
			%ifdef ONLY_NASM
				CALL [%1]
			%else
				extern %1
				CALL [%1]
			%endif
			%assign %$params %$params*4
			%if %$params <> 0
				add esp,%$params
			%endif
		%endif
	%else
		CALL	%1
		%assign %$params %$params*4
		%if %$params <> 0
			add esp,%$params
		%endif
	%endif
	%pop
%endmacro



;------------- for internal local functions


;=============== [ LOCAL FUNCTIONS   *LOCCALL* ] =====
; examples :
; loccall LocalFunction,ADDR_ msg
; loccall Message,  " Some Text " , " title "
;
;======================================= 

%imacro loccall 1-*  
%assign i	%0
	%if %0 > 1
		%rep %0 - 1
			%rotate -1  
			%assign i	i-1
			; ===== ADDR_
			%rotate -1
			%ifidni %1,"ADDR_"
				%rotate 1
				lea	eax,	[%1]
				push	eax
				%rotate -1
				%assign i	i-1
			%else		
				%rotate 1
				STDPUSH {%1}
			%endif
			

			%if i <=1
				%exitrep
			%endif
		%endrep		
		%rotate -1
	%endif  
	CALL %1
%endmacro
;===================== [ LOCAL FUNCTIONS END *LOCCALL* ]


;===============================================
;  PROC ENDPROC  and STACK locals  by PedroGC
;____________________________________________________
; proc	funcao3,arg_1,arg_2,arg_3
;
;	         stack	hwnd,4,msg,MSG_size,var_3,10
;
;mov eax,[@hwnd]
;mov eax,[@msg]
;  return                ; go to end of proc
;
;mov eax,[@var_3]
;mov eax,[@arg_1]
;
;return TRUE         ; go to end of proc and  eax = 1
;
;mov eax,[@arg_2]
;mov eax,[@arg_3]
;endproc	funcao3
;--------------------------------------------------------------
;                                   dword = 4 
;=================================================
%imacro proc 1-*.nolist
	%assign SizeLocalAdd 0  ; inicializar o size das locais a zero
	%assign stack_var  1     ; inicializar a stack pra primeira  variavel declarada
	%assign c_l 1  ; INICILIZAR OS ARGUMENTOS PARA O PRIMEIRO !
	%assign n_l %0-1
	%assign numarg_ %0-1   ; para fazer ret final
	%define nome_rotina %1

	%push proc
	global %1
	%1:
	push ebp
	mov ebp,esp
	;== loop para defenir parametros
	%rep %0-1
		%rotate 1
		%xdefine @%1  ebp+4 +c_l*4 
		%assign c_l c_l+1
	%endrep      
	;=== loop end  para defenir parametros
%endmacro
;; ==================

;---
;Usage: proc Function
;            uses edi,esi,"C"
;       endproc
;Saves the register at start of proc and retains at the end of function
;automatically. Also it makes a proc, a C proc too. 
;---
%imacro uses 1-*.nolist
	%ifctx proc
		%push uses
		%assign %$j 1
		%assign %$count %0
		%rep %0
			%ifstr %1
				%ifidni %1,"C"
					%define __@CFunction
					%assign %$count %$count-1
					%rotate 1
				%endif
			%else
				%xdefine %$reg_%$j %1
				push dword %1
				%assign %$j %$j+1
				%rotate 1
			%endif
		%endrep
	%else
		%error "'USES' must be used inside 'PROC/ENDPROC'"
	%endif
%endmacro


;======================
; START STACK  LOCALS
;======================
; tipo par de argumentos sem fim
; stack var1,4,var2,4,msg,28
;======================

%imacro stack 1-*.nolist
	%ifctx proc
		%assign %%pare_Argts ((%0) / 2)
		%assign _SomaDasLocais_ 0
		%rep %%pare_Argts
			%assign SizeLocalAdd SizeLocalAdd +%2
			%xdefine @%1 ebp-SizeLocalAdd 
			%assign stack_var stack_var+1          
			%assign _SomaDasLocais_ _SomaDasLocais_ +%2
			%rotate 2
		%endrep        ; end loop para defenir parametros
		sub esp , _SomaDasLocais_
	%endif
%endmacro



;=====================
;  END STACK LOCALS
;=====================
%imacro endproc 0-1.nolist
	terminar_ nome_rotina
	%ifctx uses
		%assign %$j %$j-1
		%rep %$count
			pop dword %$reg_%$j
			%assign %$j %$j-1
		%endrep
		%pop
	%endif
	%ifctx proc
		leave
		%ifdef __@CFunction
			ret
		%else
			%if numarg_
				ret 4*numarg_
			%else
				ret
			%endif
		%endif
		%pop
	%endif
%endmacro

;; ==========_ret  ========================
;; return macro  , can only be used in proc endproc
;; ======================================
%imacro  return  0-1.nolist
	%if %0
		%ifidn %1,1    ;; %if %1=1  doesn't work !?
			xor     eax, eax
			inc     eax
		%elifidn %1,0   ;; %if %1=0  doesn't work !?
			xor     eax, eax
		%else
			mov eax, %1
		%endif
	%endif
	l_ret_l
%endmacro

%macro terminar_ 1
        %1terminar_:
%endmacro
%macro _brincar 2
             jmp near %1%2
%endmacro
%macro l_ret_l 0
            _brincar nome_rotina,terminar_
%endmacro
;===== undef resolved  =============================
;; PROC END PROC and STACK locals macros by Nguga
;;==============================================




;;================================
;; MACRO  str2int     int2str by Written by mastercpp.
;;================================
%macro str2int 1
        push    ebx ;
        push    esi ;
        push    edi ;
        mov ebx, 0
        mov ecx, 0
        xor eax,eax
        mov ebx,0000000Ah
        mov esi,%1
        %%ConvertLoop:
        movzx ecx,byte [esi] ;Zeichen laden.
        test ecx,ecx
        jz  short %%ExitConvertLoop ;0 => Exit
        inc esi
        sub cl,30h ;0-9...
        mul ebx ;Ergebnis * 10
        add eax,ecx ;+ nchste Ziffer
        jmp short %%ConvertLoop
        %%ExitConvertLoop:
        pop     edi
        pop     esi
        pop     ebx
%endmacro

%macro int2str 2
        push    ebx ;
        push    esi ;
        push    edi ;
        %%start:
        mov  eax, %1
        xor  ecx, ecx
        mov  ebx, 000ah
        %%DecConvert:
        xor  edx,  edx
        div  ebx
        add  edx,  0030h
        push edx
        inc  ecx
        or   eax,  eax
        jnz  short %%DecConvert
        mov  edi,  %2
        %%SortDec:
        pop   eax
        stosb
        loop  %%SortDec
        mov eax, 0h
        stosb
        pop     edi
        pop     esi
        pop     ebx
%endmacro
;;================================
;; mastercpp  end macros
;;================================
